#include "AnimatableUserWidget.h"

#pragma region Animatable User Widget

UAnimatableUserWidget::UAnimatableUserWidget(const FObjectInitializer& ObjectInitializer) : Super(ObjectInitializer) {
	Animations = TArray<UUserWidgetAnimation*>();
}

UUserWidgetAnimation* UAnimatableUserWidget::CreateUserWidgetAnimation(
	const TArray<FUserWidgetAnimationData>& DataArray) 
{
	UUserWidgetAnimation* Animation = UUserWidgetAnimation::CreateUserWidgetAnimation(DataArray);
	Animations.Add(Animation);
	BindUserWidgetAnimationDelegates(Animation);
	return Animation;
}

void UAnimatableUserWidget::BindUserWidgetAnimationDelegates(
	UUserWidgetAnimation* UserWidgetAnimation)
{
	UserWidgetAnimation->UserWidgetAnimationOnStart.AddUniqueDynamic(
		this, &UAnimatableUserWidget::UserWidgetAnimationOnStart);
	UserWidgetAnimation->UserWidgetAnimationOnPause.AddUniqueDynamic(
		this, &UAnimatableUserWidget::UserWidgetAnimationOnPause);
	UserWidgetAnimation->UserWidgetAnimationOnStop.AddUniqueDynamic(
		this, &UAnimatableUserWidget::UserWidgetAnimationOnStop);
	UserWidgetAnimation->UserWidgetAnimationOnJumpTo.AddUniqueDynamic(
		this, &UAnimatableUserWidget::UserWidgetAnimationOnJumpTo);
}

void UAnimatableUserWidget::UserWidgetAnimationOnStart(
	UUserWidgetAnimation* UserWidgetAnimation, const EForward& Forward)
{
}

void UAnimatableUserWidget::UserWidgetAnimationOnPause(
	UUserWidgetAnimation* UserWidgetAnimation)
{
}

void UAnimatableUserWidget::UserWidgetAnimationOnStop(
	UUserWidgetAnimation* UserWidgetAnimation)
{
}

void UAnimatableUserWidget::UserWidgetAnimationOnJumpTo(
	UUserWidgetAnimation* UserWidgetAnimation, const float& Time)
{
}

// Template function on how to construct an animation
void UAnimatableUserWidget::TEMPLATECONSTRUCTANIMATION(UWidget* SomeWidgetToAnimate)
{
	TArray<FUserWidgetAnimationData> UserWidgetAnimationDataArray;
	UserWidgetAnimationDataArray.Add(
		FUserWidgetAnimationData(
			SomeWidgetToAnimate,
			TMap<ETransformType, FUserWidgetAnimationKeyFrameValues>
			{
				{	ETransformType::Opacity, 
					FUserWidgetAnimationKeyFrameValues(
						TMap<int32, float>{ 
							{0, 0.0f},
							{100, 1.0f}
						}
					)
				}
			}
		)
	);
	UUserWidgetAnimation* MyUserWidgetAnimation = 
		CreateUserWidgetAnimation(UserWidgetAnimationDataArray);
	BindUserWidgetAnimationDelegates(MyUserWidgetAnimation);
}

#pragma endregion