#pragma once

// Change YOURGAME_API to be the API of your game

#include "CoreMinimal.h"
#include "UObject/Object.h"
#include "Blueprint/UserWidget.h"
#include "UserWidgetAnimation.h"
#include "AnimatableUserWidget.generated.h"

#pragma region Animatable User Widget

UCLASS(Abstract)
class YOURGAME_API UAnimatableUserWidget : public UUserWidget
{
	GENERATED_BODY()
protected:
	UPROPERTY()
	TArray<UUserWidgetAnimation*> Animations;
	UUserWidgetAnimation* CreateUserWidgetAnimation(
		const TArray<FUserWidgetAnimationData>& DataArray);
	void BindUserWidgetAnimationDelegates(
		UUserWidgetAnimation* UserWidgetAnimation);
	UFUNCTION()
	void UserWidgetAnimationOnStart(
			UUserWidgetAnimation* UserWidgetAnimation,
			const EForward& Forward);
	UFUNCTION()
	void UserWidgetAnimationOnPause(
			UUserWidgetAnimation* UserWidgetAnimation);
	UFUNCTION()
	void UserWidgetAnimationOnStop(
			UUserWidgetAnimation* UserWidgetAnimation);
	UFUNCTION()
	void UserWidgetAnimationOnJumpTo(
			UUserWidgetAnimation* UserWidgetAnimation,
			const float& Time);
	// Template function on how to construct an animation
	void TEMPLATECONSTRUCTANIMATION(UWidget* SomeWidgetToAnimate);
public:
	UAnimatableUserWidget(const FObjectInitializer& ObjectInitializer);
};

#pragma endregion